/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.records;


import com.tabajara.base.tables.Telefones;
import com.tabajara.base.tables.interfaces.ITelefones;

import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record3;
import org.jooq.Row3;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TelefonesRecord extends UpdatableRecordImpl<TelefonesRecord> implements VertxPojo, Record3<Integer, String, String>, ITelefones {

    private static final long serialVersionUID = -2004204916;

    /**
     * Setter for <code>public.telefones.telid</code>.
     */
    @Override
    public TelefonesRecord setTelid(Integer value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>public.telefones.telid</code>.
     */
    @Override
    public Integer getTelid() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>public.telefones.telnumero</code>.
     */
    @Override
    public TelefonesRecord setTelnumero(String value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>public.telefones.telnumero</code>.
     */
    @Override
    public String getTelnumero() {
        return (String) get(1);
    }

    /**
     * Setter for <code>public.telefones.fkfunmatricula</code>.
     */
    @Override
    public TelefonesRecord setFkfunmatricula(String value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>public.telefones.fkfunmatricula</code>.
     */
    @Override
    public String getFkfunmatricula() {
        return (String) get(2);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record3 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row3<Integer, String, String> fieldsRow() {
        return (Row3) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row3<Integer, String, String> valuesRow() {
        return (Row3) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return Telefones.TELEFONES.TELID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return Telefones.TELEFONES.TELNUMERO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field3() {
        return Telefones.TELEFONES.FKFUNMATRICULA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getTelid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getTelnumero();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component3() {
        return getFkfunmatricula();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getTelid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getTelnumero();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value3() {
        return getFkfunmatricula();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TelefonesRecord value1(Integer value) {
        setTelid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TelefonesRecord value2(String value) {
        setTelnumero(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TelefonesRecord value3(String value) {
        setFkfunmatricula(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TelefonesRecord values(Integer value1, String value2, String value3) {
        value1(value1);
        value2(value2);
        value3(value3);
        return this;
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public void from(ITelefones from) {
        setTelid(from.getTelid());
        setTelnumero(from.getTelnumero());
        setFkfunmatricula(from.getFkfunmatricula());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public <E extends ITelefones> E into(E into) {
        into.from(this);
        return into;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TelefonesRecord
     */
    public TelefonesRecord() {
        super(Telefones.TELEFONES);
    }

    /**
     * Create a detached, initialised TelefonesRecord
     */
    public TelefonesRecord(Integer telid, String telnumero, String fkfunmatricula) {
        super(Telefones.TELEFONES);

        set(0, telid);
        set(1, telnumero);
        set(2, fkfunmatricula);
    }

    public TelefonesRecord(io.vertx.core.json.JsonObject json) {
        this();
        fromJson(json);
    }
}
